#!/usr/bin/perl -w

# This script was originally published at: scripts.tropicalpcsolutions.com


$UNIX = "0";             # Change to 1 if running UNIX or Cygwin, leave as 0 for ActiveState
$host = "localhost";     # Enter the IP address of the client machine
                         # Set to localhost to easily test on one box

# Create new blank log
$log="results.temp";
open (EP, "> $log") || die "Error: can't open results file: $!";
print (EP "");
close (EP) || die "Error: can't close results file: $!";

use IO::Socket::INET;
print "LogSearch v1 - Server Program - By Dave Lauderdale\n";

# Set listening port to collect flags
$listenSocket=new IO::Socket::INET->new(

	LocalPort=>1778,
	Proto=>'udp'
)
or die "can't bind listenSocket: $@\n";

# Set sending port to send data
$sendSocket=new IO::Socket::INET->new(

	PeerPort=>1777,
	Proto=>'udp',
	PeerAddr=>$host
)
or die "can't bind sendSocket: $@\n";

# Keep receiving flags from client
while(1)
{
    $listenSocket->recv($flag,25);

    if($flag eq 'rmlogs') { 
	if($UNIX =="1") { return; }
        else { system("del /F *.log"); }
     }

    if($flag ne 'svrexit')
    {
        # Apache users may need to modify this to point to your servers access log file
        if($UNIX == "1") { `grep -i "$flag" access_log > results.temp`; }
        else { system("findstr /I /C:\"$flag\" *.log > results.temp"); }

        # Send results to client
        open (EP,"results.temp") || die "Error: can't open results file: $!";
		@content = (<EP>);
        	$sendSocket->send(" @content \n");
        close(EP) || die "Error: can't close results file: $!";
    }

    # If user sends exit flag
    else { print "Client sent the 'exit' flag..."; die; }
}


